

#    MIDAS Access Client  for the  XPRAYSNUCAMAccess service

global env
source [file join $env(MIDASBASE) SOAP tcl MIDASAccessClient.tcl]    ;#   load default support procedures

global XPRAYSNUCAMAccessServerHost XPRAYSNUCAMAccessServerPort

if {[info exists XPRAYSNUCAMAccessServerHost] == 0} then {set XPRAYSNUCAMAccessServerHost localhost}
if {[info exists XPRAYSNUCAMAccessServerPort] == 0} then {set XPRAYSNUCAMAccessServerPort 8015}


variable uri "urn:XPRAYSNUCAMAccessServer"
variable proxy "http://$XPRAYSNUCAMAccessServerHost:$XPRAYSNUCAMAccessServerPort/XPRAYSNUCAMAccessServer"

set XPRAYSNUCAMAccessServerTimeOut 10000

SOAP::create XPRAYSNUCAMAccessClient__Verbose -proxy $proxy -uri $uri -timeout 1000 \
     -name  AccessServerVerbose \
     -params {opt int} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create XPRAYSNUCAMAccessClient__Get -proxy $proxy -uri $uri -timeout $XPRAYSNUCAMAccessServerTimeOut \
     -name Get \
     -params {Address int} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create XPRAYSNUCAMAccessClient__Set -proxy $proxy -uri $uri -timeout $XPRAYSNUCAMAccessServerTimeOut \
     -name Set \
     -params {Address int Value int} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create XPRAYSNUCAMAccessClient__SetBitRegister -proxy $proxy -uri $uri -timeout $XPRAYSNUCAMAccessServerTimeOut \
     -name SetBitRegister \
     -params {Address int Value string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply



package provide XPRAYSNUCAMAccessClient 1.0
