
#    Note:  This is loaded into the namespace  PGRIS_Diagnostics

#variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

    variable JS ""
    variable LogFlag

   if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click

}

if {$started == 0} {
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""

    variable AddrSpaceList

    variable Offset0x0000
    variable Offset0x0100
    variable Offset0x0200
    variable Offset0x0300
    variable Offset0x0400

    variable AddrSpace
    variable Address
    variable Offset
    variable SData
    variable GData


     set AddrSpaceList [list \
         "I2C Control: 0x0000" \
         "Mask Register: 0x0100" \
         "Calibration Register: 0x0200" \
         "Readout Control: 0x0300" \
         "Timestamp Control: 0x0400" \
    ]

    set Offset0x0000 [list \
        ":  0x00"  \
        ":  0x01"  \
        ":  0x02"  \
        ":  0x03"  \
        ":  0x04"   \
        ":  0x05"  \
        ":  0x06"   \
        ":  0x07"  \
        ":  0x08"  \
        ":  0x09"  \
        ":  0x0a"  \
    ]

    set Offset0x0100 [list \
        ":  0x00"  \
        ":  0x01"  \
        ":  0x02"  \
        ":  0x03"  \
        ":  0x04"   \
        ":  0x05"  \
        ":  0x06"   \
        ":  0x07"  \
        ":  0x08"  \
        ":  0x09"  \
        ":  0x0a"  \
    ]

    set Offset0x0200 [list \
        ":  0x00"  \
        ":  0x01"  \
        ":  0x02"  \
        ":  0x03"  \
        ":  0x04"   \
        ":  0x05"  \
        ":  0x06"   \
        ":  0x07"  \
        ":  0x08"  \
        ":  0x09"  \
        ":  0x0a"  \
    ]

    set Offset0x0300 [list \
        ":  0x00"  \
        ":  0x01"  \
        ":  0x02"  \
        ":  0x03"  \
        ":  0x04"   \
        ":  0x05"  \
        ":  0x06"   \
        ":  0x07"  \
        ":  0x08"  \
        ":  0x09"  \
        ":  0x0a"  \
    ]

    set Offset0x0400 [list \
        ":  0x00"  \
        ":  0x01"  \
        ":  0x02"  \
        ":  0x03"  \
        ":  0x04"   \
        ":  0x05"  \
        ":  0x06"   \
        ":  0x07"  \
        ":  0x08"  \
        ":  0x09"  \
        ":  0x0a"  \
    ]



    set Address 0x0000
    set AddrSpace [lindex $AddrSpaceList 0]
    set Offset 0
    set SData            0x0000
    set GData            ******

   proc  show_variables {} {
        variable AddrSpace
        variable Address
        variable Offset
        variable SData
        variable GData

        InsertLog "AddrSpace=$AddrSpace; Address=$Address; Offset=$Offset; SetData=$SData; GetData=$GData"
   }

   proc RunTest {i} {

       set rc [catch {source [file join Tests $i.tcl]} m]
       InsertLog "Test $i returned rc=$rc and message\n $m"
   }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogText
       variable ShowLogFlag
       variable LogFlag
       variable Address
       variable AddrSpace
       variable Offset
       variable SData
       variable GData

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
          InsertLog "CGI data is too short: $cgDiagnostics.tmlidata"
       } else {
          if {[lindex $cgidata 0] != "Widget"} then {
             InsertLog "Invalid CGI data: $cgidata"
          } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

            switch -glob $w {

                RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                SELECT   {}
                RELOAD   {}
                VARIABLES {show_variables}

                HIDE     {set ShowLogFlag 0}
                SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                SET      {WritePGRISRegister [expr $Address + $Offset] $SData}
                GET      {set GData [ReadPGRISRegister [expr $Address + $Offset]]}
                SETGET   {
                    WritePGRISRegister [expr $Address + $Offset] $SData
                    set GData [ReadPGRISRegister [expr $Address + $Offset]]
                }

                ADDRSPACE  {
                    set Address [last [lindex $cgidata 1]]
                    set AddrSpace "[lreplace [lindex $cgidata 1] 0 0]"
                    set Offset 0
                }
                OFFSET     {set Offset [last [lindex $cgidata 1]]}
                SDATA      {set SData  [last [lindex $cgidata 1]]}

                EXPERT   {$vl [third [lindex $cgidata 1]]}

                MainLog {}
                undefined {}
                default {InsertLog "unexpected CGI data:  $cgidata"}
            }
         }
      }
   }

}   ;# end of if {$started == 0} 

